﻿using System;
using System.Windows.Forms;
using Eneter.Messaging.Diagnostic;
using Eneter.Messaging.Threading.Dispatching;

namespace CalculatorClient2
{
    internal class UiThreadDispatching : IThreadDispatcherProvider
    {
        private class ToUiThreadDispatcher : IThreadDispatcher
        {
            private Control myDispatcher;

            public ToUiThreadDispatcher(Control dispatcher)
            {
                myDispatcher = dispatcher;
            }

            public void Invoke(Action workItem)
            {
                using (EneterTrace.Entering())
                {
                    if (myDispatcher.InvokeRequired)
                    {
                        myDispatcher.Invoke(workItem);
                    }
                    else
                    {
                        workItem.Invoke();
                    }
                }
            }
        }

        private ToUiThreadDispatcher myDispatcher;

        public UiThreadDispatching(Control dispatcher)
        {
            myDispatcher = new ToUiThreadDispatcher(dispatcher);
        }

        public IThreadDispatcher GetDispatcher()
        {
            return myDispatcher;
        }
    }
}
